/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */
#include "card.h"

void cardDeal(card_t *source, uint8_t *sourceSize, card_t *dest,
  uint8_t *destSize
) {
  card_t card;
  uint8_t i;

  // Take Card
  i = *sourceSize - 1;
  card = source[i];
  *sourceSize = i;

  // Put card
  i = *destSize;
  dest[i] = card;
  *destSize = i+1;
}

void cardHandSort(card_t *cards, uint8_t length) {
  // arraySortUint8(cards, length);
  arraySort(sizeof(card_t), cards, (int32_t)length, &_cardSorter);
}

int32_t _cardSorter(const void* left, const void* right) {
  card_t cardL = *((card_t *)left);
  card_t cardR = *((card_t *)right);

  uint8_t suitL = cardGetSuit(cardL);
  uint8_t suitR = cardGetSuit(cardR);
  if(suitL != suitR) return suitL - suitR;

  uint8_t numberL = cardGetNumber(cardL);
  uint8_t numberR = cardGetNumber(cardR);

  // Make Aces have higher weight (reversed)
  if(numberL == CARD_ACE) {
    return numberR == CARD_ACE ? 0 : -1;
  } else if(numberR == CARD_ACE) {
    return 1;
  }

  // Get the suit and the value of the card (reversed)
  return numberR - numberL;
}